
; Initialization Code for PIC24FJ128GA008, Family: GP control, Package: 80-Pin TQFP 80pins

.include "p24FJ128GA008.inc"



; Filter Controls used to Generate Code:

; POR Match Filter OFF

; Provisioned Feature Filter OFF

; Masks are Ignored and uses UnMasked Register Writes

.GLOBAL _VisualInitialization

; Feature=fuses - fuses (DCR) configuration

; B14=JTSAGEN B13=GCP B12=GWRP B11=DEBUG B10=COE B7=FWDTEN B6=WINDIS B4=FWPSA B3:0=WDTPS3:0
	config __CONFIG1, 0x3D1F

; B15=IESO B10:8=FNOSC2:0 B7:6=FCKSM1:0 B5=OSCIOFCN B1:0=POSCMOD1:0
	config __CONFIG2, 0x01E3

.text

_VisualInitialization:

; Feature=Interrupts - Disable Interrupts during configuration

; clear int flags:

; B13=AD B12=U1TX B11=U1RX B10=SPI1 B9=SPF1 B8=T3

; B7=T2 B6=OC2 B5=IC2 B3=T1 B2=OC1 B1=IC1 B0=INT0
	CLR IFS0

; B15=U2TX B14=U2RX B13=INT2 B12=T5 B11=T4 B10=OC4 B9=OC3

; B4=INT1 B3=CN B2=CM B1=MI2C1 B0=SI2C1
	CLR IFS1

; B13=PMP B9=OC5 B7=IC5 B6=IC4 B5=IC3

; B1=SPI2 B0=SPF2
	CLR IFS2

; B14=RTCC B6=INT4 B5=INT3 B1=MI2C2 B2=SI2C2
	CLR IFS3

; B3=CRC B2=U2ER B1=U1ER
	CLR IFS4
	CLR IEC0
	CLR IEC1
	CLR IEC2
	CLR IEC3
	CLR IEC4

; Feature=Reset - Reset configuration

; B15=TRAPR B14=IOPWR

; B7=EXTR B6=SWR B5=SWDTEN B4=WDTO B3=SLEEP B2=IDLE B1=BOR B0=POR
	CLR RCON

; Feature=Oscillator - Oscillator configuration

; method to override OSCCON write protect

; B13:12=COSC1:0 B9:8=NOSC1:0
	CLR.B W0

	MOV.B #0x78, W1

	MOV.B #0x9A, W2

	MOV.W #OSCCON, W3

	MOV.B W1, [W3+1]

	MOV.B W2, [W3+1]

	MOV.B W0, [W3+1]

; B7:6=POST1:0 B5=LOCK B3=CF B1=SOSCEN B0=OSWEN
	CLR.B W0

	MOV.B #0x46, W1

	MOV.B #0x57, W2

	MOV.B W1, [W3+0]

	MOV.B W2, [W3+0]

	MOV.B W0, [W3+0]

; B15=ROI B14:12=DOZE2:0 B11=DOZEN B10:8=FRCDIV2:0

; B7:6=PLLPOST1:0 B4:0=PLLPRE4:0
	CLR CLKDIV

; Feature=A2D - A2D configuration
                    ; force all A2D ports to digital IO at first
	MOV #0xFFFF, W0
	MOV W0, AD1PCFG

; Feature=IOPortA - IO Ports configuration

; B15:0=A15:0
	CLR PORTA                              ; enable
	MOV #0xC6FF, W0                        ; direction in=1
	MOV W0, TRISA
	CLR ODCA                               ; direction in=1

; Feature=IOPortB - IO Ports configuration

; B15:0=B15:0
	CLR PORTB                              ; enable
	MOV #0xFF00, W0                        ; direction in=1
	MOV W0, TRISB
	CLR ODCB                               ; direction in=1

; Feature=IOPortC - IO Ports configuration

; B15:0=C15:0
	CLR PORTC                              ; enable
	MOV #0xC6FF, W0                        ; direction in=1
	MOV W0, TRISC
	CLR ODCC                               ; direction in=1

; Feature=IOPortD - IO Ports configuration

; B15:0=D15:0
	CLR PORTD                              ; enable
	MOV #0xC6FF, W0                        ; direction in=1
	MOV W0, TRISD
	CLR ODCD                               ; direction in=1

; Feature=IOPortE - IO Ports configuration

; B15:0=D15:0
	CLR PORTE                              ; enable
	MOV #0xC6FF, W0                        ; direction in=1
	MOV W0, TRISE
	CLR ODCE                               ; direction in=1

; Feature=IOPortF - IO Ports configuration

; B15:0=F15:0
	CLR PORTF                              ; enable
	MOV #0xC6FF, W0                        ; direction in=1
	MOV W0, TRISF
	CLR ODCF                               ; direction in=1

; Feature=IOPortG - IO Ports configuration

; B15:0=G15:0
	CLR PORTG                              ; enable
	MOV #0xC6FF, W0                        ; direction in=1
	MOV W0, TRISG
	CLR ODCG                               ; direction in=1

; Feature=CN1 - Input Change Notification configuration

; B15:0=CN15:0
	CLR CNEN1                              ; enable change notification
	CLR CNPU1                              ; enable pullup change notification

; B6:0=CN21:16
	CLR CNEN2                              ; enable change notification
	CLR CNPU2                              ; enable pullup change notification

; Feature=Timer1 - Timers configuration
	CLR T1CON                              ; stop timer

; Feature=Timer2 - Timers configuration
	CLR T2CON                              ; stop timer

; Feature=Timer3 - Timers configuration
	CLR T3CON                              ; stop timer

; Feature=Timer4 - Timers configuration
	CLR T4CON                              ; stop timer

; Feature=Timer5 - Timers configuration
	CLR T5CON                              ; stop timer

; Feature=Timer1 - Timers configuration
	CLR TMR1                               ; timer register
	MOV #0xFFFF, W0                        ; period register
	MOV W0, PR1

; Feature=Timer3 - Timers configuration
	CLR TMR3                               ; timer register
	CLR TMR3HLD                            ; timer holding register for 32bit
	MOV #0x0020, W0                        ; period register
	MOV W0, PR3

; Feature=Timer2 - Timers configuration
	CLR TMR2                               ; timer register
	MOV #0x0020, W0                        ; period register
	MOV W0, PR2

; Feature=Timer4 - Timers configuration
	CLR TMR4                               ; timer register
	MOV #0xFFFF, W0                        ; period register
	MOV W0, PR4

; Feature=Timer5 - Timers configuration
	CLR TMR5                               ; timer register
	CLR TMR5HLD                            ; timer holding register for 32bit
	MOV #0xFFFF, W0                        ; period register
	MOV W0, PR5

; Feature=IC1 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC1CON

; Feature=IC2 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC2CON

; Feature=IC3 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC3CON

; Feature=IC4 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC4CON

; Feature=IC5 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC5CON

; Feature=OC1 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC1CON

; Feature=OC2 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC2CON

; Feature=OC3 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC3CON

; Feature=OC4 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC4CON

; Feature=OC5 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC5CON

; Feature=OC1 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC1RS
	CLR OC1R
	CLR OC1CON

; Feature=OC2 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC2RS
	CLR OC2R
	CLR OC2CON

; Feature=OC3 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC3RS
	CLR OC3R
	CLR OC3CON

; Feature=OC4 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC4RS
	CLR OC4R
	CLR OC4CON

; Feature=OC5 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC5RS
	CLR OC5R
	CLR OC5CON

; Feature=SPI1 - SPI configuration

; SPInBUF:    SPI n buffer

; SPInSTAT:   B15=SPIEN B13=SPISIDL B10:8=SPIBEC2:0 B6=SPIROV B5=SPITBF B0=SPIRBF

; SPInCON1(H): B12=DISSCK B11=DISSDO B10=MODE16 B9=SMP B8=CKE

; SPInCON1(L): B7=SSEN B6=CKP B5=MSTEN B4:2=SPRE2:0 B1:0=PPRE1:0

; SPInCON2(H): B15=FRMEN B14=SPIFSD B13=SPIFPOL

; SPInCON2(L): B1=SPIFE B0=SPIBEN
	MOV SPI1BUF, W0
	CLR SPI1STAT
	CLR SPI1CON1
	CLR SPI1CON2

; Feature=SPI2 - SPI configuration

; SPInBUF:    SPI n buffer

; SPInSTAT:   B15=SPIEN B13=SPISIDL B10:8=SPIBEC2:0 B6=SPIROV B5=SPITBF B0=SPIRBF

; SPInCON1(H): B12=DISSCK B11=DISSDO B10=MODE16 B9=SMP B8=CKE

; SPInCON1(L): B7=SSEN B6=CKP B5=MSTEN B4:2=SPRE2:0 B1:0=PPRE1:0

; SPInCON2(H): B15=FRMEN B14=SPIFSD B13=SPIFPOL

; SPInCON2(L): B1=SPIFE B0=SPIBEN
	MOV SPI2BUF, W0
	CLR SPI2STAT
	CLR SPI2CON1
	CLR SPI2CON2

; Feature=I2C1 - I2C configuration

; B7:0: receive register bits7:0
	MOV I2C1RCV, W0

; B9:0: address register bits9:0
	CLR I2C1ADD

; B8:0: baud rate generator bits 8:0
	CLR I2C1BRG

; B15=ACKSTAT B14=TRSTAT B10=BCL B9=GCSTAT B8=ADD10

; B7=IWCOL B6=I2COV B5=D_A B4=P B3=S B2=R_W B1=RBF B0=TBF
	CLR I2C1STAT

; B15=I2CEN B13=I2CSIDL B12=SCLREL B11=IPMIEN B10=A10M B9=DISSLW B8=SMEN

; B7=GCEN B6=STREN B5=ACKDT B4=ACKEN B3=RCEN B2=PEN B1=RSEN B0=SEN
	MOV #0x1000, W0
	MOV W0, I2C1CON

; Feature=I2C2 - I2C configuration

; B7:0: receive register bits7:0
	MOV I2C2RCV, W0

; B9:0: address register bits9:0
	CLR I2C2ADD

; B8:0: baud rate generator bits 8:0
	CLR I2C2BRG

; B15=ACKSTAT B14=TRSTAT B10=BCL B9=GCSTAT B8=ADD10

; B7=IWCOL B6=I2COV B5=D_A B4=P B3=S B2=R_W B1=RBF B0=TBF
	CLR I2C2STAT

; B15=I2CEN B13=I2CSIDL B12=SCLREL B11=IPMIEN B10=A10M B9=DISSLW B8=SMEN

; B7=GCEN B6=STREN B5=ACKDT B4=ACKEN B3=RCEN B2=PEN B1=RSEN B0=SEN
	MOV #0x1000, W0
	MOV W0, I2C2CON

; Feature=UART1 - UART 1 configuration
	MOV #0x0033, W0                        ; UART1 baud rate generator
	MOV W0, U1BRG
	MOV #0x8000, W0                        ; enabling UART flushes buffers
	MOV W0, U1MODE

; B15=UTXISEL1 B14=UTXINV B15=UTXISEL0	 B11=UTXBRK B10=UTXEN B9=UTXBF B8=TRMT

; B7:6=URXISEL1:0 B5=ADDEN B4=RIDLE B3=PERR B2=FERR B1=OERR B0=URXDA
	MOV #0x0510, W0
	MOV W0, U1STA

; B15=UARTEN B13=USIDL B12=IREN B11=RTSMD B9:8=UEN1:0

; B7=WAKE B6=LPBACK B5=ABAUD B4=RXINV B5=BRGH B2:1=PDSEL1:0 B0=STSEL
	MOV #0x8000, W0
	MOV W0, U1MODE

; Feature=UART2 - UART 2 configuration
	CLR U2BRG                              ; UART2 baud rate generator
	MOV #0x8000, W0                        ; enabling UART flushes buffers
	MOV W0, U2MODE

; B15=UTXISEL1 B14=UTXINV B15=UTXISEL0	 B11=UTXBRK B10=UTXEN B9=UTXBF B8=TRMT

; B7:6=URXISEL1:0 B5=ADDEN B4=RIDLE B3=PERR B2=FERR B1=OERR B0=URXDA
	MOV #0x0110, W0
	MOV W0, U2STA

; B15=UARTEN B13=USIDL B12=IREN B11=RTSMD B9:8=UEN1:0

; B7=WAKE B6=LPBACK B5=ABAUD B4=RXINV B5=BRGH B2:1=PDSEL1:0 B0=STSEL
	CLR U2MODE

; Feature=A2D - A2D configuration
                    ; Turn off A2D before setting registers
	CLR AD1CON1

; B15:0=CSSL15:0
	CLR AD1CSSL

; B15:14=CH0NB1:0 B11:8=CH0SB3:0

; B7=CH0NA B3:0=CH0SA3:0
	CLR AD1CHS

; B15:0=PCFG15:0
	CLR AD1PCFG

; B15=ADRC B12:8=SAMC4:0 B7:0=ADCS7:0
	CLR AD1CON3

; B15:13=VCFG2:0 B10=CSCNA

; B7=BUFS B5:2=SMPI B1=BUFM B0=ALTS
	CLR AD1CON2

; B15=ADON B13=ADSIDL B9:8=FORM

; B7:5=SSRC B2=ASAM B1=SAMP B0=DONE
	CLR AD1CON1

; Feature=RTC - RTCC configuration

; B15=ALRMEN B14=CHIME B13:10=AMASK3:0 B9:8=ALRMPTR1:0

; B7:0=ARPT7:0
	CLR ALCFGRPT
                    ; Turn on RTC Write before setting registers
	MOV #0x2000, W0
	MOV W0, RCFGCAL

; B15=RTCEN B13=RTCWREN B12=RTCSYNC B11=HALFSEC B10=RTCOE B9:8=RTCPTR1:0

; B7:0=CAL7:0
	CLR RCFGCAL

; Feature=PMP - PMP/PSP configuration

; B15=PMPEN B13=PSIDL B12:11=ADRMUX1:0 B10=PTBEEN B9=PTWREN B8=PTRDEN

; B7:6=CSF1:0 B5=ALP B4=CS2P B3=CS1P B2:BEP B1:WRSP B0:RDSP
	CLR PMCON

; B15=BUSY B14:13=IRQM1:0 B12:11=INCM1:0 B10=MODE16 B9:8=MODE1:0

; B7:6=WAITB1:0 B5:2=WAITM3:0 B1:0=WAITE1:0
	CLR PMMODE

; B15=CS2 B14=CS1 B13:0= Node Address
	CLR PMADDR

; B15:0=PTEN15:0
	CLR PMAEN

; B15=IBF B14=IBOV B11=IB3F B10=IB2F B9=IB1F B8=IB0F

; B7=OBE B6=OBUF B3=OB3E B2=OB2E B1=OB1E B0=OB0E
	CLR PMSTAT

; B1=RTSECSEL B0=PMPTTL`
	CLR PADCFG1

; Feature=required - Interrupt flags cleared and interrupt configuration

; interrupt priorities IP

; B14:12=T1 B10:8=OC1 B6:4=IC1 B2:0=INTO
	MOV #0x4444, W0
	MOV W0, IPC0

; B14:12=T2 B10:8=OC2 B6:4=IC2
	MOV #0x4440, W0
	MOV W0, IPC1

; B14:12=U1RX B10:8=SPI1 B6:4=SPF1 B2:0=T3
	MOV #0x4444, W0
	MOV W0, IPC2

; B6:4=AD1 B2:0=U1TX
	MOV #0x0044, W0
	MOV W0, IPC3

; B14:12=CN B10:8=CM B6:4=MI2C1 B2:0=SI2C1
	MOV #0x4444, W0
	MOV W0, IPC4

; B2:0=INT1
	MOV #0x0004, W0
	MOV W0, IPC5

; B14:12=T4 B10:8=OC4 B6:4=OC3
	MOV #0x4440, W0
	MOV W0, IPC6

; B14:12=U2TX B10:8=U2RX B6:4=INT2 B2:0=T5
	MOV #0x4444, W0
	MOV W0, IPC7

; B6:4=SPI2 B2:0=SPF2
	MOV #0x0044, W0
	MOV W0, IPC8

; B14:12=IC5 B10:8=IC4 B6:4=IC3
	MOV #0x4440, W0
	MOV W0, IPC9

; B6:4=OC5
	MOV #0x0040, W0
	MOV W0, IPC10

; B6:4=PMP
	MOV #0x0040, W0
	MOV W0, IPC11

; B10:8=MI2C2 B6:4=SI2C2
	MOV #0x0440, W0
	MOV W0, IPC12

; B10:8=INT4 B6:4=INT3
	MOV #0x0440, W0
	MOV W0, IPC13

; B10:8=RTCC

; B14:12=CRC B10:8=U2ER B6:4=U1ER
	MOV #0x0400, W0
	MOV W0, IPC15

; external interrupt enables

; B15=NSTDIS

; B4=MATHERR B3=ADDRERR B2=STKERR B1=OSCFAIL
	CLR INTCON1

; B15=ALTIVT B14=DISI B4:0=INTnEP4:0
	CLR INTCON2

; Feature=Timer1 - Start timers

; Timers1: B15=TON B13=TSIDL B6=TGATE B5:4=TCKPS1:0 B2=TSYNC B1=TCS
	CLR T1CON

; Feature=Timer3 - Start timers

; Timers3,5:   B15=TON B13=TSIDL B6=TGATE B5:4=TCKPS1:0 B1=TCS
	MOV #0x8000, W0
	MOV W0, T3CON

; Feature=Timer2 - Start timers

; Timers2,4:   B15=TON B13=TSIDL B6=TGATE B5:4=TCKPS1:0 B3=T32 B1=TCS
	MOV #0x8000, W0
	MOV W0, T2CON

; Feature=Timer5 - Start timers

; Timers3,5:   B15=TON B13=TSIDL B6=TGATE B5:4=TCKPS1:0 B1=TCS
	CLR T5CON

; Feature=Timer4 - Start timers

; Timers2,4:   B15=TON B13=TSIDL B6=TGATE B5:4=TCKPS1:0 B3=T32 B1=TCS
	CLR T4CON

; Feature=CPU - CPU register configuration
	CLR SR
	CLR SR
	CLR W0
	CLR W1
	CLR W2
	CLR W3

; Feature=Interrupts - enable interrupts

; feature interrupt enables IE

; B13=AD B12=U1TX B11=U1RX B10=SPI1 B9=SPF1 B8=T3

; B7=T2 B6=OC2 B5=IC2 B3=T1 B2=OC1 B1=IC1 B0=INT0
	CLR IEC0

; B15=U2TX B14=U2RX B13=INT2 B12=T5 B11=T4 B10=OC4 B9=OC3

; B4=INT1 B3=CN B2=CM B1=MI2C1 B0=SI2C1
	CLR IEC1

; B13=PMP B9=OC5 B7=IC5 B6=IC4 B5=IC3

; B1=SPI2 B0=SPF2
	CLR IEC2

; B14=RTCC B6=INT4 B5=INT3 B1=MI2C2 B2=SI2C2
	CLR IEC3

; B3=CRC B2=U2ER B1=U1ER
	CLR IEC4

	return
